' TPG Usage Monitor v1.3
' by twig* (twigboy@tpg.com.au)
'
' code based upon OptusNet "Yes" Usage Monitor
' feel free to email me about any queries
' please do not modify code and claim it is yours
'
' [Version History]
' v1.3
' - TPG changed their page slightly from "Ends :" to "Expiry Date:" for billing period ending.
'	Edited RetrieveDataFromServer() to retrieve "billPeriodEnd" from the correct location.
'
' v1.2 - Thanks to sealish@whirlpool forums for doing something I couldn't be bothered doing
' - Added GetBillingPeriodDaysRemaining(), which returns the numbers of days left before TPG
'	takes money from you again.
' - Added GetMegabytesPerDayRemaining(), which returns an approximate indication of how much
'	quota you should use in a day before your usage is resetted without getting capped.
' - General code cleanup
'
' v1.1
' - Fixed a bug that causes script to read from Internet Explorer cache, rather than refreshing it.
'
' v1.0
' - Initial release.
'


' Configuration
username = "adslxxxx"
password = "xxxxxxxx"


'[ there isnt really a need to edit anything below this line, unless tpg changes their page layout ]

' returns mbs downloaded in billing period
Function GetUsage
	GetUsage = Private_FindCacheValue("used")
End Function


' returns usage charges on account
Function GetUsageCharges
	GetUsageCharges = Private_FindCacheValue("usageCharges")
End Function


' returns date of the end of billing period
Function GetBillingPeriodEnd
	GetBillingPeriodEnd = Private_FindCacheValue("billPeriodEnd")
End Function


' returns the days remaining for your billing period
Function GetBillingPeriodDaysRemaining
	Dim dateEnd, dateToday, dateSeconds

	dateEnd = Private_FindCacheValue("billPeriodEnd")
	dateSeconds = DateDiff("s", date, dateEnd)

	If (dateSeconds < 0) Then
		dateSeconds = 0
	End If

	GetBillingPeriodDaysRemaining = Int(dateSeconds / 86400)
End Function


' returns the megabytes per day remaining until the end of your billing period
Function GetMegabytesPerDayRemaining
	' assuming that your limit is 20gb
	' subtract how many mb's are used so far
	' and divide that value by the number of days remaining in your billing period

	GetMegabytesPerDayRemaining = (20000 - Private_FindCacheValue("used")) / GetBillingPeriodDaysRemaining()
End Function


' returns amount owing/credit on account balance
Function GetAccountBalance
	GetAccountBalance = Private_FindCacheValue("balance")
End Function


' returns package/plan description
Function GetPackageType
	GetPackageType = Private_FindCacheValue("package")
End Function


' returns hours remaining
Function GetHoursRemaining
	GetHoursRemaining = Private_FindCacheValue("hours")
End Function


' returns download charges
Function GetDownloadCharges
	GetDownloadCharges = Private_FindCacheValue("downloadCharges")
End Function


' returns expiry date for account (i dont really know what its for, just might be useful to someone)
Function GetExpiryDate
	GetExpiryDate = Private_FindCacheValue("expiryDate")
End Function



'[ anything below this line does not require editing unless you know what you are doing! ]

' Get raw html from server and write it to a "cache" file
' NOTE: this page is only updated daily, so there is no point updating it every minute
Function RetrieveDataFromServer
	Randomize
	Dim objXMLHTTP, sHTML, sURL, sWrite

	sURL = "https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage&random=" & Rnd
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")

	' extract raw stats from server
	objXMLHTTP.Open "POST", sURL, False
	objXMLHTTP.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
	objXMLHTTP.Send "check_username=" + username + "&password=" + password
	sHTML = objXMLHTTP.responseText

	' write values to "cache" file
	sWrite = sWrite + "balance="		+ Private_FindRawValue(sHTML, "<B>Account Balance:  </b>", "</td>") + VbCrlf
	sWrite = sWrite + "package="		+ Private_FindRawValue(sHTML, "<b>Package Type:</b>", "</td>") + VbCrlf
	sWrite = sWrite + "hours="		+ Private_FindRawValue(sHTML, "<b>Hours Left: </b>", "</td>") + VbCrlf
	sWrite = sWrite + "downloadCharges="	+ Private_FindRawValue(sHTML, "<b>Download Charges:</b>", "</td>") + VbCrlf
	sWrite = sWrite + "expiryDate="		+ Private_FindRawValue(sHTML, "<b>Expiry Date:</b>", "</td>") + VbCrlf
	sWrite = sWrite + "used="		+ Private_FindRawValue(sHTML, "Download used: ", " MB") + VbCrlf
	sWrite = sWrite + "usageCharges="	+ Private_FindRawValue(sHTML, "Usage Charges: ", "<BR>") + VbCrlf
	sWrite = sWrite + "billPeriodEnd="	+ Private_FindRawValue(sHTML, "<b>Expiry Date:</b>", "</td>") + VbCrlf

	' for debugging
	'RetrieveDataFromServer = objXMLHTTP.responseText

	' open and write to file, then clean up
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set f  = fs.CreateTextFile("tpg_usage.txt", true)
	f.write(sWrite)
	f.close
	Set f  = Nothing
	Set fs = Nothing
End Function


' returns value, found inside the whole chunk of html
' find = prefix before value
' tail = tail text after value, to know when to stop reading value
Function Private_FindRawValue(html, find, tail)
	Dim leftMark, rightmark

	leftMark = instr(html, find)
	leftMark = leftMark + len(find)
	rightMark = instr(leftMark, html, tail)
	Private_FindRawValue = trim(mid(html, leftMark, (rightMark - leftMark)))
End Function


' returns a value from the "cache" file
' find = info id
Function Private_FindCacheValue(find)
	Dim leftMark, rightmark, txt

	txt = Private_ReadCacheFile
	leftMark = instr(txt, find) + 1	' add 1 for "=" sign
	leftMark = leftMark + len(find)
	rightMark = instr(leftMark, txt, VbCrlf)
	Private_FindCacheValue = trim(mid(txt, leftMark, (rightMark - leftMark)))
End Function


' Read the contents from the "cache" file
Function Private_ReadCacheFile
	Dim contents
	Set fs = CreateObject ("Scripting.FileSystemObject")

	If (fs.FileExists("tpg_usage.txt")) Then
		Set filePath = fs.GetFile("tpg_usage.txt")
		Set File = filePath.OpenAsTextStream (1, -2)
		contents = file.readall
		File.Close
		Set filePath = nothing
		Set fs = nothing
		Set File = nothing
	Else
		RetrieveDataFromServer()
		contents = Private_ReadCacheFile()
	End If

	Private_ReadCacheFile = contents
End Function